function[Data_Unproc]=data_extract(data)
% Alerts_No = count(data,"[Classification:")%Number of alerts
tempdata1 = strsplit(data,'\n'); %Split alert file into cells using newline
Csize1=length(tempdata1); %length of split cell 
k=1;
%Extract the first three cells after an empty line
for i=1:Csize1-2   
    if(find(contains(tempdata1{i},'[**]'))==1)
        if(find(contains(tempdata1{i},'(spp_arpspoof)'))==1)
            tempdata2{k}=tempdata1{i};
            tempdata2{k+1}='[Classification: Protocol Command Decode] [Priority: 2] ';
            tempdata2{k+2}=tempdata1{i+1};
            k=k+3;
        else
            tempdata2{k}=tempdata1{i};
            tempdata2{k+1}=tempdata1{i+1};
            tempdata2{k+2}=tempdata1{i+2};
            k=k+3;
        end
    end
end
Csize2=length(tempdata2);
%store header information
Data_Unproc={'Timestamp','Sig_ID','Alert Description','Alert Category','Source IP Adress','Source Port No','Destination IP Adress','Destination Port No'};
j=2;%Initialise variable
%Extract required fields
for i=1:3:Csize2-2
    [token1,remain1] = strtok(tempdata2{i},'[**] [');
    %Process for Signature IDs
    temp=strsplit(token1,':');
    Sig_ID=temp(2);      
    %Process for alert description
    [Alert_Description,~] = strtok(remain1,'[**]');
    
    %Process for alert category   
    Alert_Category = extractBetween(tempdata2{i+1},'Classification: ',']');    
    
    %Initialise Source and Destination ports and IPs
    Source_IP=' ';
    Source_Port=' ';
    Destination_IP=' ';
    Destination_Port=' ';
    
    %Process for timestamp, IP_address and Port Nos
    if(find(contains(tempdata2{i},'(spp_arpspoof)'))==1)
        Timestamp=tempdata2{i+2};        
    else
        temp1=strsplit(tempdata2{i+2},' ');
        Timestamp=temp1(1);
        Source_IP=temp1(2);%Assign a temporary Source IP
        Destination_IP=strtrim(temp1(4));%initialise Destination IP;trim trailing whitespace
        % Extract Source IP adress and Port Number
        if(find(contains(Source_IP,':'))==1)
            Source_Port=extractAfter(Source_IP,':'); 
            Source_IP= extractBefore(Source_IP,':');    
        end
        % Extract Destination IP adress and Port Number
        if(find(contains(Destination_IP,':'))==1)
            Destination_Port=extractAfter(Destination_IP,':'); 
            Destination_IP= extractBefore(Destination_IP,':');
        end
    end
    %Unprocessed Data
    Data_Unproc(j,:)={Timestamp,Sig_ID,Alert_Description,Alert_Category,Source_IP,Source_Port,Destination_IP,Destination_Port};
    j=j+1;
end
end


