function [Acc,No_Experiments,Start_Points]=evaluate(Method,A_Rand,Observ_Symbols,sSize,Evaluation_Data,A_EM, B_EM,A_EM_BW,B_EM_BW,A_EM_SKM,B_EM_SKM, A_Unif_BW,B_Unif_BW,A_Unif_SKM,B_Unif_SKM,A_Rand_BW,B_Rand_BW,A_Rand_SKM,B_Rand_SKM,A_Count_BW,B_Count_BW,A_Count_SKM,B_Count_SKM,A_SA_AHK, B_SA_AHK,A_SA_AHK_BW,B_SA_AHK_BW,A_SA_AHK_SKM,B_SA_AHK_SKM,A_SA_HMM, B_SA_HMM,A_SA_HMM_BW,B_SA_HMM_BW,A_SA_HMM_SKM,B_SA_HMM_SKM,A_DE,B_DE,A_DE_BW,B_DE_BW,A_DE_SKM,B_DE_SKM,B_KmeansD,A_KmeansD_BW,B_KmeansD_BW,A_KmeansD_SKM,B_KmeansD_SKM,B_KmeansP,A_KmeansP_BW,B_KmeansP_BW,A_KmeansP_SKM,B_KmeansP_SKM);
%create sequence and states row matrices
Evaluation_Seq(1,:)=Evaluation_Data(1:end,1);
Evaluation_States(1,:)=Evaluation_Data(1:end,2);

%Initialise arrays to store accuracy values for AS states
Acc_AS_EM=[]; Acc_AS_Unif_BW=[]; Acc_AS_Rand_BW=[]; Acc_AS_Count_BW=[];
Acc_AS_SA_AHK=[];Acc_AS_SA_HMM=[];Acc_AS_DE=[];Acc_AS_KmeansD=[];Acc_AS_KmeansP=[]; 
Acc_AS_EM_BW=[];Acc_AS_EM_SKM=[];Acc_AS_Unif_SKM=[];Acc_AS_Rand_SKM=[];
Acc_AS_Count_SKM=[];Acc_AS_SA_AHK_BW=[];Acc_AS_SA_AHK_SKM=[];Acc_AS_SA_HMM_BW=[];
Acc_AS_SA_HMM_SKM=[];Acc_AS_DE_BW=[];Acc_AS_DE_SKM=[];Acc_AS_KmeansD_BW=[];
Acc_AS_KmeansD_SKM=[];Acc_AS_KmeansP_BW=[];Acc_AS_KmeansP_SKM=[];


%Initialise arrays to store accuracy values for current state
Acc_CS_EM=[]; Acc_CS_Unif_BW=[]; Acc_CS_Rand_BW=[]; Acc_CS_Count_BW=[];
Acc_CS_SA_AHK=[];Acc_CS_SA_HMM=[];Acc_CS_DE=[];Acc_CS_KmeansD=[];Acc_CS_KmeansP=[];
Acc_CS_EM_BW=[];Acc_CS_EM_SKM=[];Acc_CS_Unif_SKM=[];Acc_CS_Rand_SKM=[];
Acc_CS_Count_SKM=[];Acc_CS_SA_AHK_BW=[];Acc_CS_SA_AHK_SKM=[];Acc_CS_SA_HMM_BW=[];
Acc_CS_SA_HMM_SKM=[];Acc_CS_DE_BW=[];Acc_CS_DE_SKM=[];Acc_CS_KmeansD_BW=[];
Acc_CS_KmeansD_SKM=[];Acc_CS_KmeansP_BW=[];Acc_CS_KmeansP_SKM=[];

%Initialise arrays to store accuracy values for Next state
Acc_NS1_EM=[]; Acc_NS1_Unif_BW=[]; Acc_NS1_Rand_BW=[]; Acc_NS1_Count_BW=[];
Acc_NS1_SA_AHK=[];Acc_NS1_SA_HMM=[];Acc_NS1_DE=[];Acc_NS1_KmeansD=[];Acc_NS1_KmeansP=[];
Acc_NS1_EM_BW=[];Acc_NS1_EM_SKM=[];Acc_NS1_Unif_SKM=[];Acc_NS1_Rand_SKM=[];
Acc_NS1_Count_SKM=[];Acc_NS1_SA_AHK_BW=[];Acc_NS1_SA_AHK_SKM=[];Acc_NS1_SA_HMM_BW=[];
Acc_NS1_SA_HMM_SKM=[];Acc_NS1_DE_BW=[];Acc_NS1_DE_SKM=[];Acc_NS1_KmeansD_BW=[];
Acc_NS1_KmeansD_SKM=[];Acc_NS1_KmeansP_BW=[];Acc_NS1_KmeansP_SKM=[];

Acc_NS2_EM=[]; Acc_NS2_Unif_BW=[]; Acc_NS2_Rand_BW=[]; Acc_NS2_Count_BW=[];
Acc_NS2_SA_AHK=[];Acc_NS2_SA_HMM=[];Acc_NS2_DE=[];Acc_NS2_KmeansD=[];Acc_NS2_KmeansP=[];
Acc_NS2_EM_BW=[];Acc_NS2_EM_SKM=[];Acc_NS2_Unif_SKM=[];Acc_NS2_Rand_SKM=[];
Acc_NS2_Count_SKM=[];Acc_NS2_SA_AHK_BW=[];Acc_NS2_SA_AHK_SKM=[];Acc_NS2_SA_HMM_BW=[];
Acc_NS2_SA_HMM_SKM=[];Acc_NS2_DE_BW=[];Acc_NS2_DE_SKM=[];Acc_NS2_KmeansD_BW=[];
Acc_NS2_KmeansD_SKM=[];Acc_NS2_KmeansP_BW=[];Acc_NS2_KmeansP_SKM=[];

%Initialise arrays to store accuracy values for Next Observation
Acc_NO1_EM=[]; Acc_NO1_Unif_BW=[]; Acc_NO1_Rand_BW=[]; Acc_NO1_Count_BW=[];
Acc_NO1_SA_AHK=[];Acc_NO1_SA_HMM=[];Acc_NO1_DE=[];Acc_NO1_KmeansD=[];Acc_NO1_KmeansP=[];
Acc_NO1_EM_BW=[];Acc_NO1_EM_SKM=[];Acc_NO1_Unif_SKM=[];Acc_NO1_Rand_SKM=[];
Acc_NO1_Count_SKM=[];Acc_NO1_SA_AHK_BW=[];Acc_NO1_SA_AHK_SKM=[];Acc_NO1_SA_HMM_BW=[];
Acc_NO1_SA_HMM_SKM=[];Acc_NO1_DE_BW=[];Acc_NO1_DE_SKM=[];Acc_NO1_KmeansD_BW=[];
Acc_NO1_KmeansD_SKM=[];Acc_NO1_KmeansP_BW=[];Acc_NO1_KmeansP_SKM=[];

Acc_NO2_EM=[]; Acc_NO2_Unif_BW=[]; Acc_NO2_Rand_BW=[]; Acc_NO2_Count_BW=[];
Acc_NO2_SA_AHK=[];Acc_NO2_SA_HMM=[];Acc_NO2_DE=[];Acc_NO2_KmeansD=[];Acc_NO2_KmeansP=[];
Acc_NO2_EM_BW=[];Acc_NO2_EM_SKM=[];Acc_NO2_Unif_SKM=[];Acc_NO2_Rand_SKM=[];
Acc_NO2_Count_SKM=[];Acc_NO2_SA_AHK_BW=[];Acc_NO2_SA_AHK_SKM=[];Acc_NO2_SA_HMM_BW=[];
Acc_NO2_SA_HMM_SKM=[];Acc_NO2_DE_BW=[];Acc_NO2_DE_SKM=[];Acc_NO2_KmeansD_BW=[];
Acc_NO2_KmeansD_SKM=[];Acc_NO2_KmeansP_BW=[];Acc_NO2_KmeansP_SKM=[];

Start_Points=[];%Array to store index
Start=1;
Stop=Start+sSize-1;
Len=length(Evaluation_Data);
%perform several tests
No_Experiments=0;%Decide on number of experiments
while Stop<Len
    No_Experiments=No_Experiments+1;
    Stop =Start+sSize-1; %Stop index
    Start_Points=[Start_Points Start];
    Observ=Evaluation_Seq(Start:Stop); %Observation row matrix
    States_Actual= Evaluation_States(Start:Stop);
    Current_State=Evaluation_States(Stop);
    Next_State=Evaluation_States(Stop+1);
    Next_Observ=Evaluation_Seq(Stop+1);
    
    Start=Start+1; %New start point
    Stop=Start+sSize-1; %New stop point
    
    %Compute the accuracy for all techniques 
    [Acc_AS_EM,Acc_CS_EM,Acc_NS1_EM,Acc_NS2_EM,Acc_NO1_EM,Acc_NO2_EM]=accuracy(Method,A_EM, B_EM,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_EM,Acc_CS_EM,Acc_NS1_EM,Acc_NS2_EM,Acc_NO1_EM,Acc_NO2_EM);
    [Acc_AS_EM_BW,Acc_CS_EM_BW,Acc_NS1_EM_BW,Acc_NS2_EM_BW,Acc_NO1_EM_BW,Acc_NO2_EM_BW]=accuracy(Method,A_EM_BW, B_EM_BW,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_EM_BW,Acc_CS_EM_BW,Acc_NS1_EM_BW,Acc_NS2_EM_BW,Acc_NO1_EM_BW,Acc_NO2_EM_BW);
    [Acc_AS_EM_SKM,Acc_CS_EM_SKM,Acc_NS1_EM_SKM,Acc_NS2_EM_SKM,Acc_NO1_EM_SKM,Acc_NO2_EM_SKM]=accuracy(Method,A_EM_SKM, B_EM_SKM,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_EM_SKM,Acc_CS_EM_SKM,Acc_NS1_EM_SKM,Acc_NS2_EM_SKM,Acc_NO1_EM_SKM,Acc_NO2_EM_SKM);
    [Acc_AS_Unif_BW,Acc_CS_Unif_BW,Acc_NS1_Unif_BW,Acc_NS2_Unif_BW,Acc_NO1_Unif_BW,Acc_NO2_Unif_BW]=accuracy(Method,A_Unif_BW, B_Unif_BW,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_Unif_BW,Acc_CS_Unif_BW,Acc_NS1_Unif_BW,Acc_NS2_Unif_BW,Acc_NO1_Unif_BW,Acc_NO2_Unif_BW);
    [Acc_AS_Unif_SKM,Acc_CS_Unif_SKM,Acc_NS1_Unif_SKM,Acc_NS2_Unif_SKM,Acc_NO1_Unif_SKM,Acc_NO2_Unif_SKM]=accuracy(Method,A_Unif_SKM, B_Unif_SKM,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_Unif_SKM,Acc_CS_Unif_SKM,Acc_NS1_Unif_SKM,Acc_NS2_Unif_SKM,Acc_NO1_Unif_SKM,Acc_NO2_Unif_SKM);
    [Acc_AS_Rand_BW,Acc_CS_Rand_BW,Acc_NS1_Rand_BW,Acc_NS2_Rand_BW,Acc_NO1_Rand_BW,Acc_NO2_Rand_BW]=accuracy(Method,A_Rand_BW, B_Rand_BW,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_Rand_BW,Acc_CS_Rand_BW,Acc_NS1_Rand_BW,Acc_NS2_Rand_BW,Acc_NO1_Rand_BW,Acc_NO2_Rand_BW);
    [Acc_AS_Rand_SKM,Acc_CS_Rand_SKM,Acc_NS1_Rand_SKM,Acc_NS2_Rand_SKM,Acc_NO1_Rand_SKM,Acc_NO2_Rand_SKM]=accuracy(Method,A_Rand_SKM, B_Rand_SKM,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_Rand_SKM,Acc_CS_Rand_SKM,Acc_NS1_Rand_SKM,Acc_NS2_Rand_SKM,Acc_NO1_Rand_SKM,Acc_NO2_Rand_SKM);
    [Acc_AS_Count_BW,Acc_CS_Count_BW,Acc_NS1_Count_BW,Acc_NS2_Count_BW,Acc_NO1_Count_BW,Acc_NO2_Count_BW]=accuracy(Method,A_Count_BW, B_Count_BW,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_Count_BW,Acc_CS_Count_BW,Acc_NS1_Count_BW,Acc_NS2_Count_BW,Acc_NO1_Count_BW,Acc_NO2_Count_BW);
    [Acc_AS_Count_SKM,Acc_CS_Count_SKM,Acc_NS1_Count_SKM,Acc_NS2_Count_SKM,Acc_NO1_Count_SKM,Acc_NO2_Count_SKM]=accuracy(Method,A_Count_SKM, B_Count_SKM,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_Count_SKM,Acc_CS_Count_SKM,Acc_NS1_Count_SKM,Acc_NS2_Count_SKM,Acc_NO1_Count_SKM,Acc_NO2_Count_SKM);
    [Acc_AS_SA_AHK,Acc_CS_SA_AHK,Acc_NS1_SA_AHK,Acc_NS2_SA_AHK,Acc_NO1_SA_AHK,Acc_NO2_SA_AHK]=accuracy(Method,A_SA_AHK, B_SA_AHK,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_SA_AHK,Acc_CS_SA_AHK,Acc_NS1_SA_AHK,Acc_NS2_SA_AHK,Acc_NO1_SA_AHK,Acc_NO2_SA_AHK);
    [Acc_AS_SA_AHK_BW,Acc_CS_SA_AHK_BW,Acc_NS1_SA_AHK_BW,Acc_NS2_SA_AHK_BW,Acc_NO1_SA_AHK_BW,Acc_NO2_SA_AHK_BW]=accuracy(Method,A_SA_AHK_BW, B_SA_AHK_BW,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_SA_AHK_BW,Acc_CS_SA_AHK_BW,Acc_NS1_SA_AHK_BW,Acc_NS2_SA_AHK_BW,Acc_NO1_SA_AHK_BW,Acc_NO2_SA_AHK_BW);
    [Acc_AS_SA_AHK_SKM,Acc_CS_SA_AHK_SKM,Acc_NS1_SA_AHK_SKM,Acc_NS2_SA_AHK_SKM,Acc_NO1_SA_AHK_SKM,Acc_NO2_SA_AHK_SKM]=accuracy(Method,A_SA_AHK_SKM, B_SA_AHK_SKM,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_SA_AHK_SKM,Acc_CS_SA_AHK_SKM,Acc_NS1_SA_AHK_SKM,Acc_NS2_SA_AHK_SKM,Acc_NO1_SA_AHK_SKM,Acc_NO2_SA_AHK_SKM);
    [Acc_AS_SA_HMM,Acc_CS_SA_HMM,Acc_NS1_SA_HMM,Acc_NS2_SA_HMM,Acc_NO1_SA_HMM,Acc_NO2_SA_HMM]=accuracy(Method,A_SA_HMM, B_SA_HMM,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_SA_HMM,Acc_CS_SA_HMM,Acc_NS1_SA_HMM,Acc_NS2_SA_HMM,Acc_NO1_SA_HMM,Acc_NO2_SA_HMM);
    [Acc_AS_SA_HMM_BW,Acc_CS_SA_HMM_BW,Acc_NS1_SA_HMM_BW,Acc_NS2_SA_HMM_BW,Acc_NO1_SA_HMM_BW,Acc_NO2_SA_HMM_BW]=accuracy(Method,A_SA_HMM_BW, B_SA_HMM_BW,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_SA_HMM_BW,Acc_CS_SA_HMM_BW,Acc_NS1_SA_HMM_BW,Acc_NS2_SA_HMM_BW,Acc_NO1_SA_HMM_BW,Acc_NO2_SA_HMM_BW);
    [Acc_AS_SA_HMM_SKM,Acc_CS_SA_HMM_SKM,Acc_NS1_SA_HMM_SKM,Acc_NS2_SA_HMM_SKM,Acc_NO1_SA_HMM_SKM,Acc_NO2_SA_HMM_SKM]=accuracy(Method,A_SA_HMM_SKM, B_SA_HMM_SKM,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_SA_HMM_SKM,Acc_CS_SA_HMM_SKM,Acc_NS1_SA_HMM_SKM,Acc_NS2_SA_HMM_SKM,Acc_NO1_SA_HMM_SKM,Acc_NO2_SA_HMM_SKM);
    [Acc_AS_DE,Acc_CS_DE,Acc_NS1_DE,Acc_NS2_DE,Acc_NO1_DE,Acc_NO2_DE]=accuracy(Method,A_DE, B_DE,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_DE,Acc_CS_DE,Acc_NS1_DE,Acc_NS2_DE,Acc_NO1_DE,Acc_NO2_DE);
    [Acc_AS_DE_BW,Acc_CS_DE_BW,Acc_NS1_DE_BW,Acc_NS2_DE_BW,Acc_NO1_DE_BW,Acc_NO2_DE_BW]=accuracy(Method,A_DE_BW, B_DE_BW,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_DE_BW,Acc_CS_DE_BW,Acc_NS1_DE_BW,Acc_NS2_DE_BW,Acc_NO1_DE_BW,Acc_NO2_DE_BW);
    [Acc_AS_DE_SKM,Acc_CS_DE_SKM,Acc_NS1_DE_SKM,Acc_NS2_DE_SKM,Acc_NO1_DE_SKM,Acc_NO2_DE_SKM]=accuracy(Method,A_DE_SKM, B_DE_SKM,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_DE_SKM,Acc_CS_DE_SKM,Acc_NS1_DE_SKM,Acc_NS2_DE_SKM,Acc_NO1_DE_SKM,Acc_NO2_DE_SKM);
    [Acc_AS_KmeansD,Acc_CS_KmeansD,Acc_NS1_KmeansD,Acc_NS2_KmeansD,Acc_NO1_KmeansD,Acc_NO2_KmeansD]=accuracy(Method,A_Rand, B_KmeansD,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_KmeansD,Acc_CS_KmeansD,Acc_NS1_KmeansD,Acc_NS2_KmeansD,Acc_NO1_KmeansD,Acc_NO2_KmeansD);
    [Acc_AS_KmeansD_BW,Acc_CS_KmeansD_BW,Acc_NS1_KmeansD_BW,Acc_NS2_KmeansD_BW,Acc_NO1_KmeansD_BW,Acc_NO2_KmeansD_BW]=accuracy(Method,A_KmeansD_BW, B_KmeansD_BW,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_KmeansD_BW,Acc_CS_KmeansD_BW,Acc_NS1_KmeansD_BW,Acc_NS2_KmeansD_BW,Acc_NO1_KmeansD_BW,Acc_NO2_KmeansD_BW);
    [Acc_AS_KmeansD_SKM,Acc_CS_KmeansD_SKM,Acc_NS1_KmeansD_SKM,Acc_NS2_KmeansD_SKM,Acc_NO1_KmeansD_SKM,Acc_NO2_KmeansD_SKM]=accuracy(Method,A_KmeansD_SKM, B_KmeansD_SKM,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_KmeansD_SKM,Acc_CS_KmeansD_SKM,Acc_NS1_KmeansD_SKM,Acc_NS2_KmeansD_SKM,Acc_NO1_KmeansD_SKM,Acc_NO2_KmeansD_SKM);
    [Acc_AS_KmeansP,Acc_CS_KmeansP,Acc_NS1_KmeansP,Acc_NS2_KmeansP,Acc_NO1_KmeansP,Acc_NO2_KmeansP]=accuracy(Method,A_Rand, B_KmeansP,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_KmeansP,Acc_CS_KmeansP,Acc_NS1_KmeansP,Acc_NS2_KmeansP,Acc_NO1_KmeansP,Acc_NO2_KmeansP);
    [Acc_AS_KmeansP_BW,Acc_CS_KmeansP_BW,Acc_NS1_KmeansP_BW,Acc_NS2_KmeansP_BW,Acc_NO1_KmeansP_BW,Acc_NO2_KmeansP_BW]=accuracy(Method,A_KmeansP_BW, B_KmeansP_BW,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_KmeansP_BW,Acc_CS_KmeansP_BW,Acc_NS1_KmeansP_BW,Acc_NS2_KmeansP_BW,Acc_NO1_KmeansP_BW,Acc_NO2_KmeansP_BW);
    [Acc_AS_KmeansP_SKM,Acc_CS_KmeansP_SKM,Acc_NS1_KmeansP_SKM,Acc_NS2_KmeansP_SKM,Acc_NO1_KmeansP_SKM,Acc_NO2_KmeansP_SKM]=accuracy(Method,A_KmeansP_SKM, B_KmeansP_SKM,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS_KmeansP_SKM,Acc_CS_KmeansP_SKM,Acc_NS1_KmeansP_SKM,Acc_NS2_KmeansP_SKM,Acc_NO1_KmeansP_SKM,Acc_NO2_KmeansP_SKM);
    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Accuracy results 1: Entire states prediction        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Compute Average accuracy for entire states prediction
Average_Acc_AS_EM=mean(Acc_AS_EM);
Average_Acc_AS_EM_BW=mean(Acc_AS_EM_BW);
Average_Acc_AS_EM_SKM=mean(Acc_AS_EM_SKM);
Average_Acc_AS_Unif_BW=mean(Acc_AS_Unif_BW);
Average_Acc_AS_Rand_BW=mean(Acc_AS_Rand_BW);
Average_Acc_AS_Count_BW=mean(Acc_AS_Count_BW);
Average_Acc_AS_Unif_SKM=mean(Acc_AS_Unif_SKM);
Average_Acc_AS_Rand_SKM=mean(Acc_AS_Rand_SKM);
Average_Acc_AS_Count_SKM=mean(Acc_AS_Count_SKM);
Average_Acc_AS_SA_AHK=mean(Acc_AS_SA_AHK);
Average_Acc_AS_SA_AHK_BW=mean(Acc_AS_SA_AHK_BW);
Average_Acc_AS_SA_AHK_SKM=mean(Acc_AS_SA_AHK_SKM);
Average_Acc_AS_SA_HMM=mean(Acc_AS_SA_HMM);
Average_Acc_AS_SA_HMM_BW=mean(Acc_AS_SA_HMM_BW);
Average_Acc_AS_SA_HMM_SKM=mean(Acc_AS_SA_HMM_SKM);
Average_Acc_AS_DE=mean(Acc_AS_DE);
Average_Acc_AS_DE_BW=mean(Acc_AS_DE_BW);
Average_Acc_AS_DE_SKM=mean(Acc_AS_DE_SKM);
Average_Acc_AS_KmeansD=mean(Acc_AS_KmeansD);
Average_Acc_AS_KmeansD_BW=mean(Acc_AS_KmeansD_BW);
Average_Acc_AS_KmeansD_SKM=mean(Acc_AS_KmeansD_SKM);
Average_Acc_AS_KmeansP=mean(Acc_AS_KmeansP);
Average_Acc_AS_KmeansP_BW=mean(Acc_AS_KmeansP_BW);
Average_Acc_AS_KmeansP_SKM=mean(Acc_AS_KmeansP_SKM);

 
%Compute Average accuracy for current state prediction
Average_Acc_CS_EM=mean(Acc_CS_EM);
Average_Acc_CS_Unif_BW=mean(Acc_CS_Unif_BW);
Average_Acc_CS_Rand_BW=mean(Acc_CS_Rand_BW);
Average_Acc_CS_Count_BW=mean(Acc_CS_Count_BW);
Average_Acc_CS_SA_AHK=mean(Acc_CS_SA_AHK);
Average_Acc_CS_SA_HMM=mean(Acc_CS_SA_HMM);
Average_Acc_CS_DE=mean(Acc_CS_DE);
Average_Acc_CS_KmeansD=mean(Acc_CS_KmeansD);
Average_Acc_CS_KmeansP=mean(Acc_CS_KmeansP);
Average_Acc_CS_EM_BW=mean(Acc_CS_EM_BW);
Average_Acc_CS_EM_SKM=mean(Acc_CS_EM_SKM);
Average_Acc_CS_Unif_SKM=mean(Acc_CS_Unif_SKM);
Average_Acc_CS_Rand_SKM=mean(Acc_CS_Rand_SKM);
Average_Acc_CS_Count_SKM=mean(Acc_CS_Count_SKM);
Average_Acc_CS_SA_AHK_BW=mean(Acc_CS_SA_AHK_BW);
Average_Acc_CS_SA_AHK_SKM=mean(Acc_CS_SA_AHK_SKM);
Average_Acc_CS_SA_HMM_BW=mean(Acc_CS_SA_HMM_BW);
Average_Acc_CS_SA_HMM_SKM=mean(Acc_CS_SA_HMM_SKM);
Average_Acc_CS_DE_BW=mean(Acc_CS_DE_BW);
Average_Acc_CS_DE_SKM=mean(Acc_CS_DE_SKM);
Average_Acc_CS_KmeansD_BW=mean(Acc_CS_KmeansD_BW);
Average_Acc_CS_KmeansD_SKM=mean(Acc_CS_KmeansD_SKM);
Average_Acc_CS_KmeansP_BW=mean(Acc_CS_KmeansP_BW);
Average_Acc_CS_KmeansP_SKM=mean(Acc_CS_KmeansP_SKM);

 
%Compute Average accuracy for next state level 1 prediction
Average_Acc_NS1_EM=mean(Acc_NS1_EM);
Average_Acc_NS1_Unif_BW=mean(Acc_NS1_Unif_BW);
Average_Acc_NS1_Rand_BW=mean(Acc_NS1_Rand_BW);
Average_Acc_NS1_Count_BW=mean(Acc_NS1_Count_BW);
Average_Acc_NS1_SA_AHK=mean(Acc_NS1_SA_AHK);
Average_Acc_NS1_SA_HMM=mean(Acc_NS1_SA_HMM);
Average_Acc_NS1_DE=mean(Acc_NS1_DE);
Average_Acc_NS1_KmeansD=mean(Acc_NS1_KmeansD);
Average_Acc_NS1_KmeansP=mean(Acc_NS1_KmeansP);
Average_Acc_NS1_EM_BW=mean(Acc_NS1_EM_BW);
Average_Acc_NS1_EM_SKM=mean(Acc_NS1_EM_SKM);
Average_Acc_NS1_Unif_SKM=mean(Acc_NS1_Unif_SKM);
Average_Acc_NS1_Rand_SKM=mean(Acc_NS1_Rand_SKM);
Average_Acc_NS1_Count_SKM=mean(Acc_NS1_Count_SKM);
Average_Acc_NS1_SA_AHK_BW=mean(Acc_NS1_SA_AHK_BW);
Average_Acc_NS1_SA_AHK_SKM=mean(Acc_NS1_SA_AHK_SKM);
Average_Acc_NS1_SA_HMM_BW=mean(Acc_NS1_SA_HMM_BW);
Average_Acc_NS1_SA_HMM_SKM=mean(Acc_NS1_SA_HMM_SKM);
Average_Acc_NS1_DE_BW=mean(Acc_NS1_DE_BW);
Average_Acc_NS1_DE_SKM=mean(Acc_NS1_DE_SKM);
Average_Acc_NS1_KmeansD_BW=mean(Acc_NS1_KmeansD_BW);
Average_Acc_NS1_KmeansD_SKM=mean(Acc_NS1_KmeansD_SKM);
Average_Acc_NS1_KmeansP_BW=mean(Acc_NS1_KmeansP_BW);
Average_Acc_NS1_KmeansP_SKM=mean(Acc_NS1_KmeansP_SKM);

%Compute Average accuracy for next state level 2 prediction
Average_Acc_NS2_EM=mean(Acc_NS2_EM);
Average_Acc_NS2_Unif_BW=mean(Acc_NS2_Unif_BW);
Average_Acc_NS2_Rand_BW=mean(Acc_NS2_Rand_BW);
Average_Acc_NS2_Count_BW=mean(Acc_NS2_Count_BW);
Average_Acc_NS2_SA_AHK=mean(Acc_NS2_SA_AHK);
Average_Acc_NS2_SA_HMM=mean(Acc_NS2_SA_HMM);
Average_Acc_NS2_DE=mean(Acc_NS2_DE);
Average_Acc_NS2_KmeansD=mean(Acc_NS2_KmeansD);
Average_Acc_NS2_KmeansP=mean(Acc_NS2_KmeansP);
Average_Acc_NS2_EM_BW=mean(Acc_NS2_EM_BW);
Average_Acc_NS2_EM_SKM=mean(Acc_NS2_EM_SKM);
Average_Acc_NS2_Unif_SKM=mean(Acc_NS2_Unif_SKM);
Average_Acc_NS2_Rand_SKM=mean(Acc_NS2_Rand_SKM);
Average_Acc_NS2_Count_SKM=mean(Acc_NS2_Count_SKM);
Average_Acc_NS2_SA_AHK_BW=mean(Acc_NS2_SA_AHK_BW);
Average_Acc_NS2_SA_AHK_SKM=mean(Acc_NS2_SA_AHK_SKM);
Average_Acc_NS2_SA_HMM_BW=mean(Acc_NS2_SA_HMM_BW);
Average_Acc_NS2_SA_HMM_SKM=mean(Acc_NS2_SA_HMM_SKM);
Average_Acc_NS2_DE_BW=mean(Acc_NS2_DE_BW);
Average_Acc_NS2_DE_SKM=mean(Acc_NS2_DE_SKM);
Average_Acc_NS2_KmeansD_BW=mean(Acc_NS2_KmeansD_BW);
Average_Acc_NS2_KmeansD_SKM=mean(Acc_NS2_KmeansD_SKM);
Average_Acc_NS2_KmeansP_BW=mean(Acc_NS2_KmeansP_BW);
Average_Acc_NS2_KmeansP_SKM=mean(Acc_NS2_KmeansP_SKM);


%Compute Average accuracy for next observation prediction
Average_Acc_NO1_EM=mean(Acc_NO1_EM);
Average_Acc_NO1_Unif_BW=mean(Acc_NO1_Unif_BW);
Average_Acc_NO1_Rand_BW=mean(Acc_NO1_Rand_BW);
Average_Acc_NO1_Count_BW=mean(Acc_NO1_Count_BW);
Average_Acc_NO1_SA_AHK=mean(Acc_NO1_SA_AHK);
Average_Acc_NO1_SA_HMM=mean(Acc_NO1_SA_HMM);
Average_Acc_NO1_DE=mean(Acc_NO1_DE);
Average_Acc_NO1_KmeansD=mean(Acc_NO1_KmeansD);
Average_Acc_NO1_KmeansP=mean(Acc_NO1_KmeansP);
Average_Acc_NO1_EM_BW=mean(Acc_NO1_EM_BW);
Average_Acc_NO1_EM_SKM=mean(Acc_NO1_EM_SKM);
Average_Acc_NO1_Unif_SKM=mean(Acc_NO1_Unif_SKM);
Average_Acc_NO1_Rand_SKM=mean(Acc_NO1_Rand_SKM);
Average_Acc_NO1_Count_SKM=mean(Acc_NO1_Count_SKM);
Average_Acc_NO1_SA_AHK_BW=mean(Acc_NO1_SA_AHK_BW);
Average_Acc_NO1_SA_AHK_SKM=mean(Acc_NO1_SA_AHK_SKM);
Average_Acc_NO1_SA_HMM_BW=mean(Acc_NO1_SA_HMM_BW);
Average_Acc_NO1_SA_HMM_SKM=mean(Acc_NO1_SA_HMM_SKM);
Average_Acc_NO1_DE_BW=mean(Acc_NO1_DE_BW);
Average_Acc_NO1_DE_SKM=mean(Acc_NO1_DE_SKM);
Average_Acc_NO1_KmeansD_BW=mean(Acc_NO1_KmeansD_BW);
Average_Acc_NO1_KmeansD_SKM=mean(Acc_NO1_KmeansD_SKM);
Average_Acc_NO1_KmeansP_BW=mean(Acc_NO1_KmeansP_BW);
Average_Acc_NO1_KmeansP_SKM=mean(Acc_NO1_KmeansP_SKM);

%Compute Average accuracy for next observation prediction
Average_Acc_NO2_EM=mean(Acc_NO2_EM);
Average_Acc_NO2_Unif_BW=mean(Acc_NO2_Unif_BW);
Average_Acc_NO2_Rand_BW=mean(Acc_NO2_Rand_BW);
Average_Acc_NO2_Count_BW=mean(Acc_NO2_Count_BW);
Average_Acc_NO2_SA_AHK=mean(Acc_NO2_SA_AHK);
Average_Acc_NO2_SA_HMM=mean(Acc_NO2_SA_HMM);
Average_Acc_NO2_DE=mean(Acc_NO2_DE);
Average_Acc_NO2_KmeansD=mean(Acc_NO2_KmeansD);
Average_Acc_NO2_KmeansP=mean(Acc_NO2_KmeansP);
Average_Acc_NO2_EM_BW=mean(Acc_NO2_EM_BW);
Average_Acc_NO2_EM_SKM=mean(Acc_NO2_EM_SKM);
Average_Acc_NO2_Unif_SKM=mean(Acc_NO2_Unif_SKM);
Average_Acc_NO2_Rand_SKM=mean(Acc_NO2_Rand_SKM);
Average_Acc_NO2_Count_SKM=mean(Acc_NO2_Count_SKM);
Average_Acc_NO2_SA_AHK_BW=mean(Acc_NO2_SA_AHK_BW);
Average_Acc_NO2_SA_AHK_SKM=mean(Acc_NO2_SA_AHK_SKM);
Average_Acc_NO2_SA_HMM_BW=mean(Acc_NO2_SA_HMM_BW);
Average_Acc_NO2_SA_HMM_SKM=mean(Acc_NO2_SA_HMM_SKM);
Average_Acc_NO2_DE_BW=mean(Acc_NO2_DE_BW);
Average_Acc_NO2_DE_SKM=mean(Acc_NO2_DE_SKM);
Average_Acc_NO2_KmeansD_BW=mean(Acc_NO2_KmeansD_BW);
Average_Acc_NO2_KmeansD_SKM=mean(Acc_NO2_KmeansD_SKM);
Average_Acc_NO2_KmeansP_BW=mean(Acc_NO2_KmeansP_BW);
Average_Acc_NO2_KmeansP_SKM=mean(Acc_NO2_KmeansP_SKM);



%Store average values for AS exxperiments in single array
if Method==1 %Include AS and CS results once
    Acc(1,:)=[sSize "AS" Average_Acc_AS_EM Average_Acc_AS_EM_BW Average_Acc_AS_EM_SKM Average_Acc_AS_SA_AHK Average_Acc_AS_SA_AHK_BW Average_Acc_AS_SA_AHK_SKM Average_Acc_AS_SA_HMM Average_Acc_AS_SA_HMM_BW Average_Acc_AS_SA_HMM_SKM Average_Acc_AS_DE Average_Acc_AS_DE_BW Average_Acc_AS_DE_SKM Average_Acc_AS_KmeansD Average_Acc_AS_KmeansD_BW Average_Acc_AS_KmeansD_SKM Average_Acc_AS_KmeansP Average_Acc_AS_KmeansP_BW Average_Acc_AS_KmeansP_SKM Average_Acc_AS_Unif_BW Average_Acc_AS_Unif_SKM Average_Acc_AS_Rand_BW Average_Acc_AS_Rand_SKM Average_Acc_AS_Count_BW Average_Acc_AS_Count_SKM];
    Acc(2,:)=[sSize "CS" Average_Acc_CS_EM Average_Acc_CS_EM_BW Average_Acc_CS_EM_SKM Average_Acc_CS_SA_AHK Average_Acc_CS_SA_AHK_BW Average_Acc_CS_SA_AHK_SKM Average_Acc_CS_SA_HMM Average_Acc_CS_SA_HMM_BW Average_Acc_CS_SA_HMM_SKM Average_Acc_CS_DE Average_Acc_CS_DE_BW Average_Acc_CS_DE_SKM Average_Acc_CS_KmeansD Average_Acc_CS_KmeansD_BW Average_Acc_CS_KmeansD_SKM Average_Acc_CS_KmeansP Average_Acc_CS_KmeansP_BW Average_Acc_CS_KmeansP_SKM Average_Acc_CS_Unif_BW Average_Acc_CS_Unif_SKM Average_Acc_CS_Rand_BW Average_Acc_CS_Rand_SKM Average_Acc_CS_Count_BW Average_Acc_CS_Count_SKM];
end
Acc(3,:)=[sSize "NS1" Average_Acc_NS1_EM Average_Acc_NS1_EM_BW Average_Acc_NS1_EM_SKM Average_Acc_NS1_SA_AHK Average_Acc_NS1_SA_AHK_BW Average_Acc_NS1_SA_AHK_SKM Average_Acc_NS1_SA_HMM Average_Acc_NS1_SA_HMM_BW Average_Acc_NS1_SA_HMM_SKM Average_Acc_NS1_DE Average_Acc_NS1_DE_BW Average_Acc_NS1_DE_SKM Average_Acc_NS1_KmeansD Average_Acc_NS1_KmeansD_BW Average_Acc_NS1_KmeansD_SKM Average_Acc_NS1_KmeansP Average_Acc_NS1_KmeansP_BW Average_Acc_NS1_KmeansP_SKM Average_Acc_NS1_Unif_BW Average_Acc_NS1_Unif_SKM Average_Acc_NS1_Rand_BW Average_Acc_NS1_Rand_SKM Average_Acc_NS1_Count_BW Average_Acc_NS1_Count_SKM];
Acc(4,:)=[sSize "NS2" Average_Acc_NS2_EM Average_Acc_NS2_EM_BW Average_Acc_NS2_EM_SKM Average_Acc_NS2_SA_AHK Average_Acc_NS2_SA_AHK_BW Average_Acc_NS2_SA_AHK_SKM Average_Acc_NS2_SA_HMM Average_Acc_NS2_SA_HMM_BW Average_Acc_NS2_SA_HMM_SKM Average_Acc_NS2_DE Average_Acc_NS2_DE_BW Average_Acc_NS2_DE_SKM Average_Acc_NS2_KmeansD Average_Acc_NS2_KmeansD_BW Average_Acc_NS2_KmeansD_SKM Average_Acc_NS2_KmeansP Average_Acc_NS2_KmeansP_BW Average_Acc_NS2_KmeansP_SKM Average_Acc_NS2_Unif_BW Average_Acc_NS2_Unif_SKM Average_Acc_NS2_Rand_BW Average_Acc_NS2_Rand_SKM Average_Acc_NS2_Count_BW Average_Acc_NS2_Count_SKM];
Acc(5,:)=[sSize "NO1" Average_Acc_NO1_EM Average_Acc_NO1_EM_BW Average_Acc_NO1_EM_SKM Average_Acc_NO1_SA_AHK Average_Acc_NO1_SA_AHK_BW Average_Acc_NO1_SA_AHK_SKM Average_Acc_NO1_SA_HMM Average_Acc_NO1_SA_HMM_BW Average_Acc_NO1_SA_HMM_SKM Average_Acc_NO1_DE Average_Acc_NO1_DE_BW Average_Acc_NO1_DE_SKM Average_Acc_NO1_KmeansD Average_Acc_NO1_KmeansD_BW Average_Acc_NO1_KmeansD_SKM Average_Acc_NO1_KmeansP Average_Acc_NO1_KmeansP_BW Average_Acc_NO1_KmeansP_SKM Average_Acc_NO1_Unif_BW Average_Acc_NO1_Unif_SKM Average_Acc_NO1_Rand_BW Average_Acc_NO1_Rand_SKM Average_Acc_NO1_Count_BW Average_Acc_NO1_Count_SKM];
Acc(6,:)=[sSize "NO2" Average_Acc_NO2_EM Average_Acc_NO2_EM_BW Average_Acc_NO2_EM_SKM Average_Acc_NO2_SA_AHK Average_Acc_NO2_SA_AHK_BW Average_Acc_NO2_SA_AHK_SKM Average_Acc_NO2_SA_HMM Average_Acc_NO2_SA_HMM_BW Average_Acc_NO2_SA_HMM_SKM Average_Acc_NO2_DE Average_Acc_NO2_DE_BW Average_Acc_NO2_DE_SKM Average_Acc_NO2_KmeansD Average_Acc_NO2_KmeansD_BW Average_Acc_NO2_KmeansD_SKM Average_Acc_NO2_KmeansP Average_Acc_NO2_KmeansP_BW Average_Acc_NO2_KmeansP_SKM Average_Acc_NO2_Unif_BW Average_Acc_NO2_Unif_SKM Average_Acc_NO2_Rand_BW Average_Acc_NO2_Rand_SKM Average_Acc_NO2_Count_BW Average_Acc_NO2_Count_SKM];
end