function [NS_L1,NO_L1,NS_L2,NO_L2,NS_L3,NO_L3]=next_state_observ_ABalpha(A,B,Old_Observ,Observ_Symbols)


Len=length(Observ_Symbols);
Nstates=[];
N=length(A);

%Compute Forward probabilities
for i=1:Len
    New_Observ=Old_Observ(i);
    Pstates = hmmdecode(New_Observ,A,B); %Obtain Probabilities of states using Forward Probability
    Nstates=[Nstates Pstates(:,end)];
end

%Create row vectors for States and Observations determination
States_Vector=[];
Observ_Vector=[];
Observ_Symbols=str2double(Observ_Symbols);
for i=1:N
    Observ_Vector=[Observ_Vector;Observ_Symbols];
    States_Vector=[States_Vector;i*ones(Len,1)];
end        

Nstates_Vector=reshape(Nstates',[],1);%Convert matrix into row vector

%Compute next state and observation for Level 1
[~,MaxIndexL1]=maxk(Nstates_Vector,1);
NS_L1=States_Vector(MaxIndexL1);
NO_L1=Observ_Vector(MaxIndexL1);

%Compute next states and observations for Level 2
[~,MaxIndexL2]=maxk(Nstates_Vector,2);
NS_L2=States_Vector(MaxIndexL2(2));
NO_L2=Observ_Vector(MaxIndexL2(2));

%Compute next states and observations for Level 3
[~,MaxIndexL3]=maxk(Nstates_Vector,3);
NS_L3=States_Vector(MaxIndexL3(3));
NO_L3=Observ_Vector(MaxIndexL3(3));


end