function [Acc_AS,Acc_CS,Acc_NS1,Acc_NS2,Acc_NO1,Acc_NO2]=accuracy(Method,A,B,Observ,Observ_Symbols,Current_State,Next_State,Next_Observ,sSize,States_Actual,Acc_AS,Acc_CS,Acc_NS1,Acc_NS2,Acc_NO1,Acc_NO2)

%Obtain State using Viterbi and Predict NO and NS
%Can be added to get rid or minimise viterbi errors
% A=normalise_rows(A);
% B=normalise_rows(B);
States_Computed = hmmviterbi(Observ,A,B);

if Method==1
    [NS1,NO1,NS2,NO2]=next_state_observ_ABalpha(A,B,Observ,Observ_Symbols);
else
    [NS1,NO1,NS2,NO2]=next_state_observ_Aalpha_Balpha(A,B,Observ,Observ_Symbols);
end
%AS computation
Comp_AS=eq(States_Actual,States_Computed);
Accuracy=nnz(Comp_AS)/sSize*100;
Acc_AS=[Acc_AS Accuracy]; 

%CS computation
Comp_CS=eq(Current_State,States_Computed(end));
Accuracy=Comp_CS*100; 
Acc_CS=[Acc_CS Accuracy];

%NS Computation Level 1
Comp_NS1=eq(Next_State,NS1);  
Accuracy=Comp_NS1*100;
Acc_NS1=[Acc_NS1 Accuracy]; 

%NS Computation Level 2
Comp_NS2=eq(Next_State,NS1)||eq(Next_State,NS2);  
Accuracy=Comp_NS2*100;
Acc_NS2=[Acc_NS2 Accuracy]; 

%NO Computation Level 1
Comp_NO1=eq(Next_Observ,NO1);  
Accuracy=Comp_NO1*100;
Acc_NO1=[Acc_NO1 Accuracy]; 

%NO Computation Level 2
Comp_NO2=eq(Next_Observ,NO1)||eq(Next_Observ,NO2);  
Accuracy=Comp_NO2*100;
Acc_NO2=[Acc_NO2 Accuracy]; 


end
