function B_KmeansD=k_means_default(M,N,Data2cluster)
%Initialise some variables
% Centroids=[];%Empty array to store centroid values
K=N*M;%Total required clusters
IDX=kmeans(Data2cluster,K); %Perfom k means clustering
DataTemp2= Data2cluster; %temporary Data
DataTemp2(:,2)=IDX;%Store clusters in second column

%Arrange data with starting with cluster 1 to K
Sorted_DataTemp2 = sortrows(DataTemp2, 2);

%Obtain the initial parameters. K cluster {C11,C12..C1M..,CNM}
%Count appearance of Cjk and divide by number of elements in cluster
Init=1;
Start=1;
for i=1:N
    for j=1:M
        Count1 = sum(Sorted_DataTemp2(:,2)==Init); 
        if Count1==0
            B_KmeansD(i,j)=0;
        else
            Stop=Start+Count1-1;
            Temp=Sorted_DataTemp2(Start:Stop,1);
            Count2=sum(Temp==j);  
            B_KmeansD(i,j)=Count2/Count1;
            Start=Stop+1;
        end
        Init=Init+1;
    end
end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

