function [NS_L1,NO_L1,NS_L2,NO_L2]=next_state_observ_Aalpha_Balpha(A,B,Old_Observ,~)
PSTATES = hmmdecode(Old_Observ,A,B); %Obtain Probabilities of states using Forward Probability
P=PSTATES(:,end); %Take probabilities at time=t as a row vector

%Probabilities for next state and observation
Prob_Next_State=P'*A;
Prob_Next_Observ=P'*B;

%Compute next state Level 1 to 2
[~,MaxIndexNS]=maxk(Prob_Next_State,2);
NS_L1=MaxIndexNS(1);
NS_L2=MaxIndexNS(2);


%Compute next observation Level 1 to 2
[~,MaxIndexNO]=maxk(Prob_Next_Observ,2);
NO_L1=MaxIndexNO(1);
NO_L2=MaxIndexNO(2);


end
