% There are 30 observations in inside, five (DDOS mstream handler to client[248/250],ICMP PING BSDtype[368],
% SNMP AgentX/tcp request[1421],SNMP public access udp[1411]
% and SNMP request udp[1417]) are absent in DMZ. DMZ has 28 alerts, three (DDOS mstream attacker to handler[2560000
%] , DDOS mstream client to handler[247/249], and  FIN number is greater than prior
% FIN[16]) are absent in inside
% For ease of evaluation, the five alert type in Inside1 and 3 alert types
% in DMZ1 were remove form the dataset.

function [Data_New,Observ_Symbols]=symbols_observations(Data_Old)
Len_Data1=length(Data_Old);% length of data

%Remove 5 observation types from Inside 1 and 2 Observation types from DMZ1
%Use SID in column 2 to delete

j=1;
for i=1:Len_Data1
    %obtain logical '1' if match with SID
    aa=isequal(Data_Old(i,2),"248");%SID to check in Inside1
    bb=isequal(Data_Old(i,2),"250");%SID to check in Inside1
    cc=isequal(Data_Old(i,2),"368");%SID to check in Inside1
    dd=isequal(Data_Old(i,2),"1411");%SID to check in Inside1
    ee=isequal(Data_Old(i,2),"1417");%SID to check in Inside1
    ff=isequal(Data_Old(i,2),"1421");%SID to check in Inside1
    gg=isequal(Data_Old(i,2),"2560000");%SID to check in DMZ1
    hh=isequal(Data_Old(i,2),"247");%SID to check in DMZ1
    ii=isequal(Data_Old(i,2),"249");%SID to check in DMZ1
    jj=isequal(Data_Old(i,2),"16");%SID to check in DMZ1
    
    %Combine results and create new entry if sum is 0
    Test=aa+bb+cc+dd+ee+ff+gg+hh+ii+jj;
    if Test==0
        Data_New(j,:)=Data_Old(i,:);
        j=j+1;
    end
end

Observ_Symbols=unique(Data_New(:,3));

No_Observ=length(Observ_Symbols);
Observ_Symbols(:,2)=1:No_Observ;

Len_Data2=length(Data_New);% length of data

for i=1:Len_Data2
    for j=1:No_Observ   
        if(find(contains(Observ_Symbols(j),Data_New(i,3))==1))
            Data_New(i,11)=j;
        end
    end
end


end