function [LLS_State_Symbols,Phase_Points]=symbols_states_DMZ1(Data_No_State_Symbols)
l=length(Data_No_State_Symbols);
LLS_State_Symbols=Data_No_State_Symbols;
%Phase start points after 1 were taken to be start of phase dump
%   State       Start Point
%   1           14:20:45.042787
%   2           15.07:07.223333
%   3           15:33:10.604234
%   4           15:50:01.741482
%   5           16:26:15.428503
Phase2_Seconds=15*3600+07*60+07.223333;
Phase3_Seconds=15*3600+33*60+10.604234;
Phase4_Seconds=15*3600+50*60+01.741482;
Phase5_Seconds=16*3600+26*60+15.428503;
%Obtain start index of each phase
for i=1:l
    Alert_Time=str2double(Data_No_State_Symbols(i,9));
    if Alert_Time<Phase2_Seconds        
        LLS_State_Symbols(i,12)='1';
        Stop_Phase1_Index=i;
    elseif Alert_Time<Phase3_Seconds        
        LLS_State_Symbols(i,12)='2';
        Stop_Phase2_Index=i;
    elseif Alert_Time<Phase4_Seconds
        LLS_State_Symbols(i,12)='3';
        Stop_Phase3_Index=i;
    elseif Alert_Time<Phase5_Seconds
        LLS_State_Symbols(i,12)='4';
        Stop_Phase4_Index=i;
    else
        LLS_State_Symbols(i,12)='5';
    end
end
%Compute start Phase indices and determine Phase start points
Start_Phase2_Index= Stop_Phase1_Index+1;
Start_Phase3_Index= Stop_Phase2_Index+1;
Start_Phase4_Index= Stop_Phase3_Index+1;
Start_Phase5_Index= Stop_Phase4_Index+1;

Phase_Points=[1 Start_Phase2_Index Start_Phase3_Index Start_Phase4_Index Start_Phase5_Index];

%Assign phase number for each alert
% LLS_state_symbols(1:start_phase2_index-1,12)='1'; 
% LLS_state_symbols(start_phase2_index:start_phase3_index-1,12)='2';
% LLS_state_symbols(start_phase3_index:start_phase4_index-1,12)='3';
% LLS_state_symbols(start_phase4_index:start_phase5_index-1,12)='4';
% LLS_state_symbols(start_phase5_index:end,12)='5';

end